/**
  *  ChildFrame
  *  ChildFrame.java
  *   
  *  @version 0.001
  *  @author jack  pippi
  */
  
 
 import java.awt.*;
 import java.awt.event.*;
 import java.lang.Object.*;
  
 import javax.swing.*;
 import javax.swing.border.*;
   
 class ChildFrame
 extends JInternalFrame
 implements ActionListener
 {
   private Container cp;
   public JTextArea  txtAusgabe;
   public JTextField txtEingabe;
   private serverThread s;	
   public ChildFrame(String title, serverThread s)
   {
   	 super("Child " + title, true, true);
   	 this.s = s;
     int x=250,y=300;
     setIconifiable(true);
     setMaximizable(false);
     setResizable(false);
     setBackground(Color.lightGray);
     setSize(x+10, y+30);      
     cp = getContentPane();
     cp.setLayout(new BorderLayout());
     init(x,y);
   }
   
   private void init(int x, int y) {     
     cp.setLayout(null);
     cp.setBounds(0,0,x,y);
     JPanel pane = new JPanel();
     		pane.setLayout(null);
     		pane.setBounds(0, 0, x, y);	
     //JScrollPane scroll = new JScrollPane();
     //scroll.setLayout(null);
     //scroll.setBounds(0, 0, x, y-20);	
   
     txtAusgabe = new JTextArea("ClientMessages:\n\n",100,100);
     txtAusgabe.setBounds(0, 0, x, y-20);
     txtAusgabe.setTabSize(4);
     txtAusgabe.setLineWrap(true);
     txtAusgabe.setWrapStyleWord(true);
     //txtAusgabe.setFont(BOLD);
     txtAusgabe.setEnabled(false);     
     pane.add(txtAusgabe);
     //scroll.add(txtAusgabe);
     
     txtEingabe = new JTextField(30);	
     txtEingabe.setEnabled(true);
     txtEingabe.setBounds(0, y-20, x, 20);  
     txtEingabe.addActionListener(this);    
     pane.add(txtEingabe);
    
     //cp.add(scroll);
     cp.add(pane);     
   }

   public void actionPerformed(ActionEvent event)
   {
     JTextField tf = (JTextField)event.getSource();  
     String msg = tf.getText();
     System.out.println("sending: "+msg);
     s.send("MSG_Server: "+msg+"\n");
     tf.setText("");
     
     /*System.out.println(tf.getSelectedText());
     System.out.println(tf.getSelectionStart());
     System.out.println(tf.getSelectionEnd());
     System.out.println(tf.getCaretPosition());*/
   }
 }
 