
/**
  *  ServerThread
  *  serverThread.java
  *   
  *  @version 0.001
  *  @author jack  pippi
  */
  
 
 import java.awt.*;
 import java.awt.event.*;

 import javax.swing.*;
 import javax.swing.border.*;
 
 import java.util.*;  
 import java.net.*;
 
 import java.io.*;
 import java.io.BufferedReader.*;
  
 class serverThread
 extends Thread
 {
   private String mc = "MSG_Client: ", ms = "MSG_Server: ";
   private BufferedInputStream in; 
   private OutputStream       out;
   private int name, Port;
   private Socket socket;
   public boolean connect;
   private DesktopFrame desk;
   private ChildFrame child;
 
   public serverThread(int name, Socket socket, int Port, DesktopFrame desk )
   {    
     this.name   = name;
     this.socket = socket;
     this.Port   = Port;
     this.desk   = desk;     
     start();
   }

   public void run()
   {
     String msg = "\n		Server: connection #" + name;
     System.out.println(msg + " established\n");
     System.out.println(" ");
     connect();
     handling();    
   } 
  
   private void handling () {  	  
  
     StringBuffer s; int c;
     connect = true ;
    
     try {
       
       System.out.println(ms+"Sent GreetingZ to client #"+name+"\n");
       send("Hello Client #"+name+"\n"); 
           
   	   while (connect) {
   	   
          /*********** receive ****************/
   	     s = new StringBuffer();
   	     String line="";
   	     while ((c = in.read()) != '\n' ) {
           s.append((char)c);        
         }     
         line = s.toString();
         System.out.println("Client #"+name+": "+line);      
         child.txtAusgabe.append(line+"\n");    
         if(line.startsWith("quit"))connect = false;                 
       }   
       close(); 
     } catch(IOException e) {      	
       System.err.println("Error in Handling!!! \n"+e.toString());
       //connect=false;
     }        	
   }
  
   private int rand(int anz) {
     Random r = new Random();
     return Math.abs(r.nextInt()) % anz;    	
   }
  
   public void send(String msg){
     try {    
       out.write(msg.getBytes());    
     } catch(IOException e) {
       System.err.println("Connection Failed : "+e.toString());
       System.exit(1);
     } 
   }
  
   private void connect() {
     try {
       child = new ChildFrame("Client #"+name+" on Port: "+Port, this);
       desk.addChild(child, 10+name*10, 10+name*10);
       
       in = new BufferedInputStream(socket.getInputStream()); 
       out = socket.getOutputStream(); 
          
       System.out.println(ms+"connected to Client on Port"+Port);       
     } catch (IOException e) {
       System.err.println("Connection Failed : "+e.toString());
       System.exit(1);
     }
   }
  
   public void close() {
     try {
       System.out.println(ms+"Connection " + name + " will close");
       in.close();
       out.close();  
     } catch (IOException e) {
       System.err.println("Can't close Connection : "+e.toString());
       System.exit(1);
     }
   }   
 } 